When /^I hover over the "(.*)" menu$/ do |element|
  page.find('a span', :text => element, :match => :prefer_exact, :visible => true).hover
end


When /^I click "([^"]*)"$/ do |id|
  click_on id
end


When /^(.*) within frame "(.*?)"$/ do |action, arg2|
  within_frame(arg2) do
    step action
  end
end

When /^(.*) waiting patiently$/ do |action|
  # Needed by nacoma, because it's infinitely slow
  using_wait_time(20) do
    step action
  end
end

Then /^I should see (?:([\d]+) )?"([^"]*)"$/ do |n, string|
  page.should have_content(string, :count => n)
end

When /^I enter "([^"]*)" into "([^"]*)"$/ do |val, sel|
  fill_in(sel % @params, :with => val)
end


When /^I click the delete icon for comment (\d+)$/ do |comment_id|
  id = "delete_comment_#{comment_id}"
  page.find(:xpath, "id('#{id}')").trigger(:click)
end

When /^I click link "([^"]*)"$/ do |link|
  click_link link
end

When /^I click button "([^"]*)"$/ do |button|
  click_button(button)
end

When /^I hover over "(.*)"$/ do |element|
  page.find(:css, "[title=\"#{element}\"], [id=\"#{element}\"], [label=\"#{element}\"]").hover
end

# This should be removed when MON-7582 (new menus, the only thing
# requiring this) is merged.
When /^I hover over the "(.*)" button$/ do |element|
  page.find("##{element.downcase}-button").hover
end


When /^I click xpath "([^"]*)"$/ do |xp|
  find(:xpath, xp).click
end

When /^I click css "([^"]*)"$/ do |xp|
  find(:css, xp).click
end

When /^I click "(.*?)" inside "(.*?)"$/ do |arg1, arg2|
  within(arg2) do
    click_on arg1
  end
end

When /^I hover over the "(.*)" on nagvis header menu$/ do |element|
  page.find('span', :text => element, :match => :prefer_exact, :visible => true).hover
end

When /^I hover over the "(.*)" on nagvis content$/ do |element|
  page.find("##{element.downcase}").hover
end


Then /^I should see (?:([\d]+) )?xpath "([^"]*)"$/ do |n, selector|
  page.should have_selector(:xpath, selector, :count => n)
end

Then /^I should see (?:([\d]+) )?css "([^"]*)"$/ do |n, selector|
  page.should have_css(selector, :count => n)
end

Then /^I should see these menu items:$/ do |table|
  rows = table.raw
  rows.each do |row|
    page.should have_link(row[0])
  end
end

#
# Text matching in output
#
Then /^I should see the "(.*)" table$/ do |tablename|
  page.has_table? tablename
end



Then /^I should see "([^"]*)", compensating for DST$/ do |string|
  #Ruby has a retarded stdlib which doesn't support manipulating datetimes
  #(timedeltas, anyone?) properly, so enjoy this filthy, filthy hack.
  #
  #NOTE: Only works for strings of the form Nd, where N is some integer between
  # 1 and 31, inclusive. FML.
  days = DateTime.strptime(string,"%dd").day
  was_dst = (DateTime.now - days).to_time.dst?
  is_dst = DateTime.now.to_time.dst?
  if was_dst and not is_dst then
    #plus one hour
    string = string + " 1h"
  elsif is_dst and not was_dst
    #minus one hour
    days = days - 1
    string = days.to_s + "d 23h"
  end
  page.should have_content(string)
end

Then /^I should see (?:([\d]+) )?link "([^"]*)"$/ do |n, string|
  page.should have_link(string, :count => n)
end

Then /^I should see button "([^"]*)"$/ do |selector|
  page.should have_button(selector)
end

Then /^I should see regex "([^"]*)"$/ do |regex|
  /#{regex}/.should match page.document.text
end

When /^I select "([^"]*)"$/ do |opt|
  select(opt)
end

When /^I select "(.*)" from "([^"]*)"$/ do |opt, sel|
  select(opt, :from => sel)
end



